﻿function changeTableColor() {    
 myDialog = app.dialogs.add ({name:"Tabellen umfärben",canCancel:true});    
    swatchlist = app.activeDocument.swatches.everyItem().name;    
    with (myDialog)    
    {    
     with (dialogColumns.add())    
     {    
      with (borderPanels.add())    
      {    
       staticTexts.add ({staticLabel:"Suchen"});    
       swf = dropdowns.add ({stringList:swatchlist, selectedIndex:0});    
       tbf = percentComboboxes.add({editValue:100, largeNudge:10, stringList:["25", "50", "75", "100"] });    
       tbfStrk = measurementEditboxes.add({editValue:0.5});    
      }    
      with (borderPanels.add())    
      {    
       staticTexts.add ({staticLabel:"Ersetzen"});    
       swr = dropdowns.add ({stringList:swatchlist, selectedIndex:0});    
       tbr = percentComboboxes.add({editValue:100, largeNudge:10, stringList:["25", "50", "75", "100"] });    
       tbrStrk = measurementEditboxes.add({editValue:0.33});    
      }    
      with (borderPanels.add())    
      {    
       dostrokes = checkboxControls.add({staticLabel:"Konturen ändern", checkedState:true});    
       dofills = checkboxControls.add({staticLabel:"Füllfarbe ändern", checkedState:true});    
      }    
     }    
    }    
    if (!myDialog.show() || !(dostrokes.checkedState || dofills.checkedState))    
    {    
     myDialog.destroy();    
     exit(0);    
    }    
    findtint = tbf.editValue;    
    findStrk = tbfStrk.editValue;    
    findswatch = app.activeDocument.swatches.item(swf.selectedIndex);    
    changetint = tbr.editValue;    
    changeStrk = tbrStrk.editValue;    
    changeswatch = app.activeDocument.swatches.item(swr.selectedIndex);    
    strokes = dostrokes.checkedState;    
    fills = dofills.checkedState;    
    fillchanges = 0;    
    strokechanges = 0;    
    tb = app.activeDocument.stories.everyItem().tables.everyItem().getElements();
    
     for (var t=tb.length-1; t>=0; t--)   {   
         
      var tab = tb[t];    
      for (var c=0; c<tab.cells.length; c++)    {
       
       var curCells = tab.cells[c];
       
       if (fills && curCells.fillColor == findswatch && curCells.fillTint == findtint)   {    
        fillchanges++;
        curCells.properties = { fillColor:changeswatch, fillTint:changetint };    
       }
   
       if (strokes)   {
        $.bp();
        s = false;
            
            if (curCells.topEdgeStrokeColor == findswatch && curCells.topEdgeStrokeTint == findtint && curCells.topEdgeStrokeWeight == findStrk)  {    
             s = true;    
             curCells.properties = {topEdgeStrokeColor:changeswatch, topEdgeStrokeTint:changetint, topEdgeStrokeWeight:changeStrk};    
            }
        
            if (curCells.bottomEdgeStrokeColor == findswatch && curCells.bottomEdgeStrokeTint == findtint && curCells.bottomEdgeStrokeWeight == findStrk)   {    
             s = true;    
             curCells.properties = {bottomEdgeStrokeColor:changeswatch, bottomEdgeStrokeTint:changetint, bottomEdgeStrokeWeight:changeStrk};    
            } 
        
            if (curCells.leftEdgeStrokeColor == findswatch && curCells.leftEdgeStrokeTint == findtint && curCells.leftEdgeStrokeWeight == findStrk)   {    
             s = true;    
             curCells.properties = {leftEdgeStrokeColor:changeswatch, leftEdgeStrokeTint:changetint, leftEdgeStrokeWeight:changeStrk};    
            } 
        
            if (curCells.rightEdgeStrokeColor == findswatch && curCells.rightEdgeStrokeTint == findtint && curCells.rightEdgeStrokeWeight == findStrk)   {    
             s = true;    
             curCells.properties = {rightEdgeStrokeColor:changeswatch, rightEdgeStrokeTint:changetint, rightEdgeStrokeWeight:changeStrk};    
            } 
        
            if (s) strokechanges++; 
        
       }    
      }    
    }  
    ch = "Keine Änderungen";    
    if (fillchanges)    
    {    
     ch = fillchanges+" Füllfarben geändert";    
     if (strokechanges)    
      ch += "\n"+strokechanges+" Konturen geändert";    
    } else if (strokechanges)    
      ch = strokechanges+" Konturen geändert";    
    //alert (ch);
 }


// das komplette Skript kann in einem Schritt rückgängig gemacht werden

try {
    app.doScript("changeTableColor()", ScriptLanguage.JAVASCRIPT , [], UndoModes.ENTIRE_SCRIPT, "changeTableColor.jsx");
    } catch (e) {
       alert("changeTableColor" + "\r" + "Error running script." + "\r" + e);
}

